import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.Scanner;

public class Cyk {
	
	public static boolean contains(final String arr, final String key) 
	{
		if (arr == null || key == null) return false;
		else return arr.contains(key);
	}
	

	public static void main(String[] args) throws FileNotFoundException 
	{
		boolean exists = false;
		// TODO Auto-generated method stub
		if (args.length == 2)
		{
			String filename = args[0];
			File file = new File(filename);
			String testString = args[1];
			Scanner fileScan = new Scanner(file);
			ArrayList<String> variables = new ArrayList<String>();
			int len = testString.length();
			String[][] table = new String[len][len];
			ArrayList<String> rules = new ArrayList<String>();
			
			
			//Parse file
			while (fileScan.hasNextLine())
			{
				String line = fileScan.nextLine();
				Scanner scan = new Scanner(line);
				scan.useDelimiter(":");
				String temp = scan.next();
				if (!variables.contains(temp)) variables.add(temp);
				rules.add(line);
				scan.close();
			}
			fileScan.close();
			
			//CYK algorithm (Modified for 2NF)
			for (int i = 1; i <= testString.length(); i++)
			{
				char k = testString.charAt(i-1);
				for (int j = 1; j <= rules.size(); j++)
				{
					if (rules.get(j-1).contains(String.valueOf(k)))
					{
						Scanner scan = new Scanner(rules.get(j-1));
						scan.useDelimiter(":");
						String variable = scan.next();				
						if (table[i-1][i-1] == null) table[i-1][i-1] = variable + "|";
						else table[i-1][i-1] += variable + "|"; //Add to table at (i,i)
						scan.close();
					}
				}
				//Modification for 2NF. Treats terminals as variables to conform to CYK
				if (table[i-1][i-1] == null) table[i-1][i-1] = testString.charAt(i-1) + "|";
				else table[i-1][i-1] += testString.charAt(i-1) + "|";
				variables.add(String.valueOf(testString.charAt(i-1)));
			}
			
			for (int l = 2; l <= len; l++)//loops through possible substrings for w
			{
				for (int i = 1; i <= len - l + 1; i++)
				{
					int j = i + l - 1; //end of substring
					for (int k = i; k <= j - 1; k++)//alters split for substring
					{
						for (int y = 1; y <= rules.size(); y++) //loops through all rules
						{							
							Scanner parser = new Scanner(rules.get(y-1));
							parser.useDelimiter(":");
							String var = parser.next();
							parser.useDelimiter(",");
							String val1, val2;
							val1 = parser.next();
							val1 = val1.substring(1, val1.length());
							parser.useDelimiter(" ");
							val2 = parser.next();
							val2 = val2.substring(1, val2.length());
							if (variables.contains(val1) && variables.contains(val2))
							{
								if (contains(table[i-1][k-1], val1) &&
										contains(table[k][j-1], val2))
								{
									if (table[i-1][j-1] == null) table[i-1][j-1] = var + "|";
									else table[i-1][j-1] += var + "|";
									//This (convoluted) loop checks for Unit productions and adds
									//to the table accordingly (modification for 2NF)
									for (int m = 1; m <= rules.size(); m++)
									{							
										Scanner parser2 = new Scanner(rules.get(m-1));
										parser2.useDelimiter(":");
										String searchVar = parser2.next();
										parser2.useDelimiter(",");
										String val3, val4;
										val3 = parser2.next();
										val3 = val3.substring(1, val3.length());
										parser2.useDelimiter(" ");
										val4 = parser2.next();
										val4 = val4.substring(1, val4.length());
										if (val3.equals(var) && val4.equals("e"))
										{
											table[i-1][j-1] += searchVar + "|";
										}
										parser2.close();
									}
								}
							}// This is a change for the fact that the grammar is in 2NF
							
							parser.close();
						}
					}
				}
			}
			if (contains(table[0][len - 1], variables.get(0)))
				exists = true;
			if (exists == false) System.out.println("NO");
			else System.out.println("YES");
		}
		else System.out.println("Invalid Format");
	}

}
